/*
  Grid2DArray.h

  Wrapper around 2D grid array.

  Copyright (C) 2005 Scott Christley

  Author: Scott Christley <schristl@nd.edu>
  Date: 2005
   
  This file is part of LimbChondrogenesis.
*/

@interface Grid2DArray : NSObject
{
  unsigned int width;
  unsigned int height;
  NSString *encode;
  void *matrix;
}

- initWithWidth: (unsigned int)aWidth andHeight: (unsigned int)aHeight andEncode: (NSString *)anEncode;

- (unsigned int)getWidth;
- (unsigned int)getHeight;
- (void *)getMatrix;
- (NSString *)getEncode;

- (void)clearMatrix;

- (int)countClusters: (BOOL)periodic;

@end
