/*
  MultiScale2DGrid.h

  Implementation of multiple 2D spatial grid overlays at different scales

  Copyright (C) 2005 Scott Christley

  Author: Scott Christley <schristl@nd.edu>
  Date: 2005
   
  This file is part of LimbChondrogenesis.
*/

#ifdef GNUSTEP
#include <Foundation/Foundation.h>
#else
#import <Cocoa/Cocoa.h>
#endif

// boundary conditions
#define PERIODIC_BOUNDARY 0
#define NOFLUX_BOUNDARY 1

@interface MultiScale2DGrid : NSObject
{
  unsigned int width;
  unsigned int height;
  NSMutableDictionary *grids;
}

- initWithWidth: (unsigned int)aWidth andHeight: (unsigned int)aHeight;
- (NSDictionary *)newGridWithName: (NSString *)name atScale: (unsigned int)scale
		       withEncode: (NSString *)encode;
- (void)removeGridWithName: (NSString *)name;
- (NSDictionary *)gridWithName: (NSString *)name;

- (int)maxValueForIntGrid: (NSString *)gridName;
- (double)maxValueForDoubleGrid: (NSString *)gridName;

- (void)dumpGrid: (NSString *)gridName toFile:(FILE *)aFile;
- (void)dumpGrid: (NSString *)gridName toFile: (FILE *)aFile withInvocation: (NSInvocation *)anInvocation;

@end
