//
//  SignalTransductionCell.h
//  LimbChondrogenesis
//
//  Created by Scott Christley on 7/10/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#ifdef GNUSTEP
#include <Foundation/Foundation.h>
#else
#import <Cocoa/Cocoa.h>
#endif

#import "BiologicalCell.h"

@interface SignalTransductionCell : BiologicalCell {
	// molecule concentrations
	int activatorInCell;
	int activatorTransmitter;
	int activatorReceiver;
	int inhibitorInCell;
	int inhibitorTransmitter;
	int inhibitorReceiver;

	// reaction parameters
	int basalActivator;
	double activatorOnActivator;
	double activatorOnInhibitor;
	int maxActivatorProduce;
	int basalInhibitor;
	double inhibitorOnActivator;
	double inhibitorOnInhibitor;
	int maxInhibitorProduce;
	int activatorMembraneTransmit;
	int activatorMembraneReceive;
	int inhibitorMembraneTransmit;
	int inhibitorMembraneReceive;
}

// accessor methods
- (int)activatorInCell;
- (int)inhibitorInCell;

- (int)basalActivator;
- (void)setBasalActivator: (int)aValue;

- (double)activatorOnActivator;
- (void)setActivatorOnActivator: (double)aValue;

- (double)activatorOnInhibitor;
- (void)setActivatorOnInhibitor: (double)aValue;

- (int)maxActivatorProduce;
- (void)setMaxActivatorProduce: (int)aValue;

- (int)basalInhibitor;
- (void)setBasalInhibitor: (int)aValue;

- (double)inhibitorOnActivator;
- (void)setInhibitorOnActivator: (double)aValue;

- (double)inhibitorOnInhibitor;
- (void)setInhibitorOnInhibitor: (double)aValue;

- (int)maxInhibitorProduce;
- (void)setMaxInhibitorProduce: (int)aValue;

- (int)activatorMembraneTransmit;
- (void)setActivatorMembraneTransmit: (int)aValue;

- (int)activatorMembraneReceive;
- (void)setActivatorMembraneReceive: (int)aValue;

- (int)inhibitorMembraneTransmit;
- (void)setInhibitorMembraneTransmit: (int)aValue;

- (int)inhibitorMembraneReceive;
- (void)setInhibitorMembraneReceive: (int)aValue;

// molecule reactions
- (void)performReaction;
- (void)performSignalTransduction;

@end
