//
//  SignalTransductionCell.m
//  LimbChondrogenesis
//
//  Created by Scott Christley on 7/10/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "SignalTransductionCell.h"

#include "internal.h"

@implementation SignalTransductionCell

- initWithColony: (CellColony *)aColony ofSize: (unsigned int)aSize
	     atX: (unsigned int)x atY: (unsigned int)y ofType: (int)aType
{
	[super initWithColony: aColony ofSize: aSize atX: x atY: y ofType: aType];
	
	activatorInCell = 0;
	activatorTransmitter = 1;
	activatorReceiver = 1;
	inhibitorInCell = 0;
	inhibitorTransmitter = 1;
	inhibitorReceiver = 1;
	
	return self;
}

//
// accessor methods
//
- (int)activatorInCell { return activatorInCell; }
- (int)inhibitorInCell { return inhibitorInCell; }

- (int)basalActivator { return basalActivator; }
- (void)setBasalActivator: (int)aValue { basalActivator = aValue; }

- (double)activatorOnActivator { return activatorOnActivator; }
- (void)setActivatorOnActivator: (double)aValue {activatorOnActivator = aValue; }

- (double)activatorOnInhibitor { return activatorOnInhibitor; }
- (void)setActivatorOnInhibitor: (double)aValue { activatorOnInhibitor = aValue; }

- (int)maxActivatorProduce { return maxActivatorProduce; }
- (void)setMaxActivatorProduce: (int)aValue { maxActivatorProduce = aValue; }

- (int)basalInhibitor { return basalInhibitor; }
- (void)setBasalInhibitor: (int)aValue { basalInhibitor = aValue; }

- (double)inhibitorOnActivator { return inhibitorOnActivator; }
- (void)setInhibitorOnActivator: (double)aValue { inhibitorOnActivator = aValue; }

- (double)inhibitorOnInhibitor { return inhibitorOnInhibitor; }
- (void)setInhibitorOnInhibitor: (double)aValue { inhibitorOnInhibitor = aValue; }

- (int)maxInhibitorProduce { return maxInhibitorProduce; }
- (void)setMaxInhibitorProduce: (int)aValue { maxInhibitorProduce = aValue; }

- (int)activatorMembraneTransmit { return activatorMembraneTransmit; }
- (void)setActivatorMembraneTransmit: (int)aValue { activatorMembraneTransmit = aValue; }

- (int)activatorMembraneReceive { return activatorMembraneReceive; }
- (void)setActivatorMembraneReceive: (int)aValue { activatorMembraneReceive = aValue; }

- (int)inhibitorMembraneTransmit { return inhibitorMembraneTransmit; }
- (void)setInhibitorMembraneTransmit: (int)aValue { inhibitorMembraneTransmit = aValue; }

- (int)inhibitorMembraneReceive { return inhibitorMembraneReceive; }
- (void)setInhibitorMembraneReceive: (int)aValue { inhibitorMembraneReceive = aValue; }

//
// molecule reactions
//

- (void)performReaction
{
	++activatorInCell;
	++inhibitorInCell;
}

- (void)performSignalTransduction
{
}

@end
